<?php

namespace EnumType;

/**
 * This class stands for CampaignNewsType EnumType
 * @subpackage Enumerations
 */
class CampaignNewsType
{
    /**
     * Constant for value 'campaign_start'
     * @return string 'campaign_start'
     */
    const VALUE_CAMPAIGN_START = 'campaign_start';
    /**
     * Constant for value 'campaign_stop'
     * @return string 'campaign_stop'
     */
    const VALUE_CAMPAIGN_STOP = 'campaign_stop';
    /**
     * Constant for value 'campaign_update_general'
     * @return string 'campaign_update_general'
     */
    const VALUE_CAMPAIGN_UPDATE_GENERAL = 'campaign_update_general';
    /**
     * Constant for value 'campaign_update_vouchercode'
     * @return string 'campaign_update_vouchercode'
     */
    const VALUE_CAMPAIGN_UPDATE_VOUCHERCODE = 'campaign_update_vouchercode';
    /**
     * Constant for value 'campaign_update_consumer'
     * @return string 'campaign_update_consumer'
     */
    const VALUE_CAMPAIGN_UPDATE_CONSUMER = 'campaign_update_consumer';
    /**
     * Constant for value 'campaign_update_commission'
     * @return string 'campaign_update_commission'
     */
    const VALUE_CAMPAIGN_UPDATE_COMMISSION = 'campaign_update_commission';
    /**
     * Constant for value 'campaign_update_incentive'
     * @return string 'campaign_update_incentive'
     */
    const VALUE_CAMPAIGN_UPDATE_INCENTIVE = 'campaign_update_incentive';
    /**
     * Constant for value 'campaign_update_material'
     * @return string 'campaign_update_material'
     */
    const VALUE_CAMPAIGN_UPDATE_MATERIAL = 'campaign_update_material';
    /**
     * Constant for value 'campaign_update_feed'
     * @return string 'campaign_update_feed'
     */
    const VALUE_CAMPAIGN_UPDATE_FEED = 'campaign_update_feed';
    /**
     * Constant for value 'campaign_update_urgent'
     * @return string 'campaign_update_urgent'
     */
    const VALUE_CAMPAIGN_UPDATE_URGENT = 'campaign_update_urgent';
    /**
     * Constant for value 'campaign_update_attribution'
     * @return string 'campaign_update_attribution'
     */
    const VALUE_CAMPAIGN_UPDATE_ATTRIBUTION = 'campaign_update_attribution';
    /**
     * Return true if value is allowed
     * @uses self::getValidValues()
     * @param mixed $value value
     * @return bool true|false
     */
    public static function valueIsValid($value)
    {
        return ($value === null) || in_array($value, self::getValidValues(), true);
    }
    /**
     * Return allowed values
     * @uses self::VALUE_CAMPAIGN_START
     * @uses self::VALUE_CAMPAIGN_STOP
     * @uses self::VALUE_CAMPAIGN_UPDATE_GENERAL
     * @uses self::VALUE_CAMPAIGN_UPDATE_VOUCHERCODE
     * @uses self::VALUE_CAMPAIGN_UPDATE_CONSUMER
     * @uses self::VALUE_CAMPAIGN_UPDATE_COMMISSION
     * @uses self::VALUE_CAMPAIGN_UPDATE_INCENTIVE
     * @uses self::VALUE_CAMPAIGN_UPDATE_MATERIAL
     * @uses self::VALUE_CAMPAIGN_UPDATE_FEED
     * @uses self::VALUE_CAMPAIGN_UPDATE_URGENT
     * @uses self::VALUE_CAMPAIGN_UPDATE_ATTRIBUTION
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_CAMPAIGN_START,
            self::VALUE_CAMPAIGN_STOP,
            self::VALUE_CAMPAIGN_UPDATE_GENERAL,
            self::VALUE_CAMPAIGN_UPDATE_VOUCHERCODE,
            self::VALUE_CAMPAIGN_UPDATE_CONSUMER,
            self::VALUE_CAMPAIGN_UPDATE_COMMISSION,
            self::VALUE_CAMPAIGN_UPDATE_INCENTIVE,
            self::VALUE_CAMPAIGN_UPDATE_MATERIAL,
            self::VALUE_CAMPAIGN_UPDATE_FEED,
            self::VALUE_CAMPAIGN_UPDATE_URGENT,
            self::VALUE_CAMPAIGN_UPDATE_ATTRIBUTION,
        );
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
