<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AffiliateSitesPaidOut StructType
 * @subpackage Structs
 */
class AffiliateSitesPaidOut extends AbstractStructBase
{
    /**
     * The affiliateSites
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - arrayType: tns:AffiliateSitePaidOutElement[]
     * - ref: SOAP-ENC:arrayType
     * @var \StructType\AffiliateSitePaidOutElement[]
     */
    public $affiliateSites;
    /**
     * Constructor method for AffiliateSitesPaidOut
     * @uses AffiliateSitesPaidOut::setAffiliateSites()
     * @param \StructType\AffiliateSitePaidOutElement[] $affiliateSites
     */
    public function __construct(array $affiliateSites = array())
    {
        $this
            ->setAffiliateSites($affiliateSites);
    }
    /**
     * Get affiliateSites value
     * @return \StructType\AffiliateSitePaidOutElement[]|null
     */
    public function getAffiliateSites()
    {
        return $this->affiliateSites;
    }
    /**
     * Set affiliateSites value
     * @throws \InvalidArgumentException
     * @param \StructType\AffiliateSitePaidOutElement[] $affiliateSites
     * @return \StructType\AffiliateSitesPaidOut
     */
    public function setAffiliateSites(array $affiliateSites = array())
    {
        foreach ($affiliateSites as $affiliateSitesPaidOutAffiliateSitesItem) {
            // validation for constraint: itemType
            if (!$affiliateSitesPaidOutAffiliateSitesItem instanceof \StructType\AffiliateSitePaidOutElement) {
                throw new \InvalidArgumentException(sprintf('The affiliateSites property can only contain items of \StructType\AffiliateSitePaidOutElement, "%s" given', is_object($affiliateSitesPaidOutAffiliateSitesItem) ? get_class($affiliateSitesPaidOutAffiliateSitesItem) : gettype($affiliateSitesPaidOutAffiliateSitesItem)), __LINE__);
            }
        }
        $this->affiliateSites = $affiliateSites;
        return $this;
    }
    /**
     * Add item to affiliateSites value
     * @throws \InvalidArgumentException
     * @param \StructType\AffiliateSitePaidOutElement $item
     * @return \StructType\AffiliateSitesPaidOut
     */
    public function addToAffiliateSites(\StructType\AffiliateSitePaidOutElement $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AffiliateSitePaidOutElement) {
            throw new \InvalidArgumentException(sprintf('The affiliateSites property can only contain items of \StructType\AffiliateSitePaidOutElement, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->affiliateSites[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AffiliateSitesPaidOut
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
